#include <GUIConstants.au3>

;-------------------------------------------------------------------------------------------
;Variables - Transition for GUI Operation
;-------------------------------------------------------------------------------------------
Dim $ed[18] ; Configuration Array for CCOven Macro
Dim $OvenFinished[40], $AlmostFinished[40], $WoodAdded[40]
Dim $WaterAdded[40], $TimeWoodAdded[40], $TimeWaterAdded[40], $GlideStep[40]
Dim $AddWaterCheck[40], $DangerAddWater[40], $AddWoodCheck[40], $AddWood[40], $OxyPrime[40]
Dim $OxyCheck[40], $VentPosition[40]
$EndLoops = 1
$Errors1 = 0
$Errors2 = 0
$Errors3 = 0
$Errors4 = 0
$Errors5 = 0
$Errors6 = 0
$Errors7 = 0
$Errors8 = 0
$ExitProgram = 0
$HeatLabel = 0
$OxyLabel = 0
$WoodLabel = 0
$WaterLabel = 0
$DangerLabel = 0
$StatLabel = 0
;-------------------------------------------------------------------------------------------

;-------------------------------------------------------------------------------------------
;Variables - Oven Window Setup
;-------------------------------------------------------------------------------------------
Dim $GUIInput[18] 
$ClientWindow = WinGetPos("eGenesis Client", "")
$WinX = $ClientWindow[0] 
$WinY = $Clientwindow[1] 
$TrimX = 0
$TrimY = 2
$RetrieveBlue = 0
$RetrieveGreen = 0
$OvenRowEnd = 5
;-------------------------------------------------------------------------------------------

;-------------------------------------------------------------------------------------------
;Variables - Oven Controls
;-------------------------------------------------------------------------------------------
$HearthWidth = 212
$HearthHeight = 266
$OvenWidth = 212
$OvenHeight = 288
$CheckBarsScanStartX = 78
$CheckBarsStartY = 168
$CheckBarsScanFinishX = 187
$AddButtonsScanX = 36
$AddButtonsConstY = 266
$BeginButtonX = 110
$BeginButtonY = 257
$CountFinished = 0
$LowHeat = 0
$HighHeat = 0
$LowOxy = 0
$HighOxy = 0
$WoodMax = 0
$WaterMax = 0
$LowDanger = 0
$HighDanger = 0


Global $Paused, $RetrieveBlue, $RetrieveGreen, $Retrieve

HotKeySet("{PAUSE}", "TogglePause")
HotKeySet("{ESC}", "Terminate")
HotKeySet("+!b", "CaptureBlue")
HotKeySet("+!g", "CaptureGreen")
HotKeySet("+!d", "ExitColorMode")

Func LoadGUI()
	$msg = 0
	$IniFileExists = 0
		If FileExists("CCOvenSettings.ini") Then
			$inifile = FileOpen("CCOvenSettings.ini", 0)
				If $inifile = -1 Then
    				MsgBox(0, "Error", "Unable to open file, Settings not loaded!")
    			EndIf
    		$iniFileExists = 1
			$cnt = 0
    		While 1
    			$cnt=$cnt+1
				$iniline = FileReadLine($inifile)
    			If @error = -1 Then ExitLoop
				$GUIInput[$cnt] = $iniline
			Wend
			FileClose($inifile)
		EndIf
	
	GuiCreate("CC Oven Macro Setup", 250, 400)
	GUICtrlCreateLabel("Amount of Ovens: ", 80, 5)
	$GUIInput1 = GuiCtrlCreateInput("1", 170, 1, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput1,2)
	$GUIInput2 = GUICtrlCreateCheckbox("Guilded", 1, 30, 55, 20)
	$GUIInput3 = GUICtrlCreateCheckbox("Auto Setup Windows", 1, 50, 120, 20)
	$GUIInput14 = GUICtrlCreateCheckBox("Check for Oven/Uncheck for Hearth", 1, 70, 200, 20)
	GUICtrlCreateLabel("Low Heat", 1, 100)
	$Label1 = GUICtrlCreateLabel("(1-111)", 116,100)
	$GUIInput4 = GuiCtrlCreateInput("1", 80, 97, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput4,3)
	GUICtrlCreateLabel("High Heat", 1, 120)
	$Label2 = GUICtrlCreateLabel("(1-111)", 116,120)
	$GUIInput5 = GuiCtrlCreateInput("1", 80, 117, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput5,3)
	GUICtrlCreateLabel("Low Oxy", 1, 140)
	$Label3 = GUICtrlCreateLabel("(1-111)", 116,140)
	$GUIInput6 = GuiCtrlCreateInput("1", 80, 137, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput6,3)
	GUICtrlCreateLabel("High Oxy", 1, 160)
	$Label4 = GUICtrlCreateLabel("(1-111)", 116,160)
	$GUIInput7 = GuiCtrlCreateInput("1", 80, 157, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput7,3)
	GUICtrlCreateLabel("Max Wood", 1, 180)
	$Label5 = GUICtrlCreateLabel("(1-111)", 116,180)
	$GUIInput8 = GuiCtrlCreateInput("1", 80, 177, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput8,3)
	GUICtrlCreateLabel("Max Water", 1, 200)
	$Label6 = GUICtrlCreateLabel("(1-111)", 116,200)
	$GUIInput9 = GuiCtrlCreateInput("1", 80, 197, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput9,3)
	GUICtrlCreateLabel("Low Danger", 1, 220)
	$Label7 = GUICtrlCreateLabel("(1-111)", 116,220)
	$GUIInput10 = GuiCtrlCreateInput("1", 80, 217, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput10,3)
	GUICtrlCreateLabel("Max Danger", 1, 240)
	$Label8 = GUICtrlCreateLabel("(1-111)", 116,240)
	$GUIInput11 = GuiCtrlCreateInput("1", 80, 237, 33, 20, 0x0001)
		GUICtrlSetLimit($GUIInput11,3)
	GUICtrlCreateLabel("HEX Green", 1, 260)
	GUICtrlCreateLabel("HEX Value of Green", 145,260)
	$GUIInput12 = GuiCtrlCreateInput("1", 80, 257, 63, 20, 0x0001)
		GUICtrlSetLimit($GUIInput12,8)
	GUICtrlCreateLabel("HEX Blue", 1, 280)
	GUICtrlCreateLabel("HEX Value of Blue", 145,280)
	$GUIInput13 = GuiCtrlCreateInput("1", 80, 277, 63, 20, 0x0001)
		GUICtrlSetLimit($GUIInput13,8)
	If $Errors1 = 1 Then GUICtrlSetColor($Label1,0xff0000)
	If $Errors2 = 1 Then GUICtrlSetColor($Label2,0xff0000)
	If $Errors3 = 1 Then GUICtrlSetColor($Label3,0xff0000)
	If $Errors4 = 1 Then GUICtrlSetColor($Label4,0xff0000)
	If $Errors5 = 1 Then GUICtrlSetColor($Label5,0xff0000)
	If $Errors6 = 1 Then GUICtrlSetColor($Label6,0xff0000)
	If $Errors7 = 1 Then GUICtrlSetColor($Label7,0xff0000)
	If $Errors8 = 1 Then GUICtrlSetColor($Label8,0xff0000)
	If $IniFileExists = 1 Then 
		GUICtrlSetData($GUIInput1, $GUIInput[1])
		if $GUIInput[2] = 1 Then GUICtrlSetState($GUIInput2, $GUI_CHECKED)
		if $GUIInput[3] = 1 Then GUICtrlSetState($GUIInput3, $GUI_CHECKED)
		if $GUIInput[14] = 1 Then GUICtrlSetState($GUIInput14, $GUI_CHECKED)
		GUICtrlSetData($GUIInput4, $GUIInput[4])
		GUICtrlSetData($GUIInput5, $GUIInput[5])
		GUICtrlSetData($GUIInput6, $GUIInput[6])
		GUICtrlSetData($GUIInput7, $GUIInput[7])
		GUICtrlSetData($GUIInput8, $GUIInput[8])
		GUICtrlSetData($GUIInput9, $GUIInput[9])
		GUICtrlSetData($GUIInput10, $GUIInput[10])
		GUICtrlSetData($GUIInput11, $GUIInput[11])
		GUICtrlSetData($GUIInput12, $GUIInput[12])
		GUICtrlSetData($GUIInput13, $GUIInput[13])
	EndIf
	If $RetrieveBlue <> 0x000000 Then GUICtrlSetData($GUIInput13, "0x" & Hex($RetrieveBlue, 6))
	If $RetrieveGreen <> 0x000000 Then GUICtrlSetData($GUIInput12,"0x" & Hex($RetrieveGreen,6))
If $iniFileExists = 1 Then 
	$savebtn = GUICtrlCreateButton ("Overwrite Settings", 1,  375, 120, 20)
EndIf
If $iniFileExists = 0 Then
	$savebtn = GUICtrlCreateButton ("Save Settings", 1,  375, 120, 20)
EndIf
$okbtn = GUICtrlCreateButton ("Start", 190,  375, 60, 20)
$GetColors = GUICtrlCreateButton ("Get Colors", 125, 375, 60, 20)
$Help = GUICtrlCreateButton ("Help", 105, 330, 40, 20)
GUISetState () 
While $msg <> $GUI_EVENT_CLOSE
	$msg = GUIGetMsg()
		If $msg = $okbtn Then 
			$Errors = 0
			$ErrorCheck = 0
			$GUIInput[1] = GUICtrlRead($GUIInput1)
			$GUIInput[2] = GUICtrlRead($GUIInput2)
			$GUIInput[3] = GUICtrlRead($GUIInput3)
			$GUIInput[4] = GUICtrlRead($GUIInput4)
			$GUIInput[5] = GUICtrlRead($GUIInput5)
			$GUIInput[6] = GUICtrlRead($GUIInput6)
			$GUIInput[7] = GUICtrlRead($GUIInput7)
			$GUIInput[8] = GUICtrlRead($GUIInput8)
			$GUIInput[9] = GUICtrlRead($GUIInput9)
			$GUIInput[10] = GUICtrlRead($GUIInput10)
			$GUIInput[11] = GUICtrlRead($GUIInput11)
			$GUIInput[12] = GUICtrlRead($GUIInput12)
			$GUIInput[13] = GUICtrlRead($GUIInput13)
			$GUIInput[14] = GUICtrlRead($GUIInput14)
			If $GUIInput[4] > 111 Then
				$Errors1 = 1
			Else
				$Errors1 = 0
			EndIf
			If $GUIInput[5] > 111 Then
				$Errors2 = 1
			Else
				$Errors2 = 0
			EndIf
			If $GUIInput[6] > 111 Then
				$Errors3 = 1
			Else
				$Errors3 = 0
			EndIf
			If $GUIInput[7] > 111 Then
				$Errors4 = 1
			Else
				$Errors4 = 0
			EndIf
			If $GUIInput[8] > 111 Then
				$Errors5 = 1
			Else
				$Errors5 = 0
			EndIf
			If $GUIInput[9] > 111 Then
				$Errors6 = 1
			Else
				$Errors6 = 0
			EndIf
			If $GUIInput[10] > 111 Then
				$Errors7 = 1
			Else
				$Errors7 = 0
			EndIf
			If $GUIInput[11] > 111 Then
				$Errors8 = 1
			Else
				$Errors8 = 0
			EndIf
			If $Errors1 or $Errors2 or $Errors3 or $Errors4 or $Errors5 or $Errors6 or $Errors7 or $Errors8 = 1 Then
				GUIDelete()
				LoadGUI()
			Else
				GUIDelete()
				Main(1)
			EndIf
		EndIf
		If $msg = $GUI_EVENT_CLOSE Then Exit 0
		If $msg = $savebtn Then 
			$inifile = FileOpen("CCOvenSettings.ini", 2)
				If $inifile = -1 Then
					MsgBox(0, "Error", "Unable to Create File, settings will not be saved!")
				Else
					FileWriteLine($inifile, GUICtrlRead($GUIInput1))
					FileWriteLine($inifile, GUICtrlRead($GUIInput2))
					FileWriteLine($inifile, GUICtrlRead($GUIInput3))
					FileWriteLine($inifile, GUICtrlRead($GUIInput4))
					FileWriteLine($inifile, GUICtrlRead($GUIInput5))
					FileWriteLine($inifile, GUICtrlRead($GUIInput6))
					FileWriteLine($inifile, GUICtrlRead($GUIInput7))
					FileWriteLine($inifile, GUICtrlRead($GUIInput8))
					FileWriteLine($inifile, GUICtrlRead($GUIInput9))
					FileWriteLine($inifile, GUICtrlRead($GUIInput10))
					FileWriteLine($inifile, GUICtrlRead($GUIInput11))
					FileWriteLine($inifile, GUICtrlRead($GUIInput12))
					FileWriteLine($inifile, GUICtrlRead($GUIInput13))
					FileWriteLine($inifile, GUICtrlRead($GUIInput14))
					FileClose($inifile)
    			EndIF
    		GUICtrlSetData($savebtn, "Overwrite Settings")
    	EndIf
    	If $msg = $GetColors Then
    		CaptureColors()
    		ExitLoop
    	EndIf
    	If $msg = $help Then
    		msgbox(0, "Help", "To exit Script at any time hit ESC." & @CRLF & "Pin all your oven windows in the " & @CR & "Upper left corner of your" & @CR & "ATITD Window and then hit START" & @CR & "in the CCOvenMacro Setup Screen")
    	EndIf
Wend
GUIDelete()
EndFunc

Func ExitColorMode()
Tooltip("")
GUIDelete()
LoadGUI()
EndFunc

Func CaptureBlue()
$GetBlue = "0x000000"
		$Retrieve = Not $Retrieve
		$GetBlue = 0x000000
			While $Retrieve
				Sleep(100)
				Tooltip('Move Mouse Pointer Over the Blue bar on your CC Oven and hit Shift-Alt-B', ($ClientWindow[2]/2)-140, $ClientWindow[1]+5)
			Wend
		$MouseLoc = MouseGetPOS()
		$GetBlue = PixelGetColor($MouseLoc[0], $MouseLoc[1])
		ToolTip('Captured Blue is: ' & Hex($GetBlue,8), ($ClientWindow[2]/2)-40, $ClientWindow[1]+5)
		Sleep(2000)
		$RetrieveBlue = $GetBlue
		CaptureColors()
EndFunc

Func CaptureGreen()
		$Retrieve = Not $Retrieve
		$GetGreen = 0x000000
			While $Retrieve
				Sleep(100)
				Tooltip('Move Mouse Pointer Over the Green bar on your CC Oven and hit Shift-Alt-G', ($ClientWindow[2]/2)-140, $ClientWindow[1]+5)
			Wend
		$MouseLoc = MouseGetPOS()
		$GetGreen = PixelGetColor($MouseLoc[0], $MouseLoc[1])
		ToolTip('Captured Green is: ' & Hex($GetGreen,8), ($ClientWindow[2]/2)-40, $ClientWindow[1]+5)
		Sleep(2000)
		$RetrieveGreen = $GetGreen
		CaptureColors()
EndFunc


Func CaptureColors()
	$Retrieve = Not $Retrieve
	While $Retrieve
		Sleep(100)
		Tooltip('Color Retrieve Mode: Shift-Alt-B to Grab Blue | Shift-Alt-G to Grab Green | Shift-Alt-D When Done', ($ClientWindow[2]/2)-180, $ClientWindow[1]+5)
	Wend
	Tooltip("")
EndFunc

Func TogglePause()
    $Paused = NOT $Paused
    While $Paused
        sleep(100)
        ToolTip('Script is "Paused"',($ClientWindow[2]/2)+40, $ClientWindow[1]+5)
    WEnd
    ToolTip("")
EndFunc

Func Terminate()
	GUIDelete()
	$ExitProgram = 6
	Exit
EndFunc

Func SetupOvens($OvenCount)
	$DragX = $WinX
	$DragY = $WinY
	$Counter = 1
	$JumpCounter = 1
		While $Counter < $OvenCount
			If $JumpCounter = $OvenRowEnd+1 Then
				$DragX = $DragX-(($JumpCounter-1) * $OvenWidth) + $TrimX
				$DragY = $DragY + $OvenHeight + $TrimY
				$JumpCounter=1
			EndIf
			$sizer = WinGetClientSize("eGenesis Client")
			MouseClickDrag("Left", ($WinX+30), ($WinY+30), ($DragX+30), ($DragY+30), 1)
			MouseUp("Left")
			Sleep(200)
			$DragX=$DragX+$OvenWidth
			$Counter = $Counter + 1
			$JumpCounter = $JumpCounter + 1
		Wend
EndFunc

Func Guild()
	$OvenWidth = 212
	$OvenHeight = 288
EndFunc

Func UnGuilded()
	$OvenWidth = 212
	$OvenHeight = 288
EndFunc

Func StartOvens($OvenCount)
	$Counter = 1
	$JumpCounter = 1
	$MoveMouseX = $WinX + $BeginButtonX
	$MoveMouseY = $WinY + $BeginButtonY
		While $Counter < $OvenCount
			If $JumpCounter = $OvenRowEnd + 1 Then
				$MoveMouseX = $MoveMouseX - (($JumpCounter - 1) * $OvenWidth) + $TrimX
				$MoveMouseY = $MoveMouseY + $OvenHeight + $TrimY
				$JumpCounter = 1
			EndIf
			MouseClick("Right", $MoveMouseX, $MoveMouseY, 1, 0)
			$MoveMouseX = $MoveMouseX + $OvenWidth
			$Counter = $Counter + 1
			$JumpCounter = $JumpCounter + 1
		Wend
EndFunc

Func ScanBar($x, $y)
	$xc = 0
	$stopthis = 0
	While $stopthis < 1
		PixelSearch($x+$xc, $y, $x+$xc, $y, $GUIInput[13], 100)
		If not @error Then
			$xc = $xc+1
		Else 
			$stopthis = 1
		EndIf
	WEnd
	return $xc
EndFunc

Func OvenStatusGUI($OvenNumber, $OvenCount)
	ToolTip('Oven: ['&$OvenNumber&']/'&$OvenCount-1&'  Heat: ['&$HeatLabel&']/113  Oxy: ['&$OxyLabel&']/113  Wood: ['&$WoodLabel&']/113  Water: ['&$WaterLabel&']/113  Danger: ['&$DangerLabel&']/113  Oven Status: ['&$StatLabel&']/113',($ClientWindow[2]/3)-180, $ClientWindow[1]+5)
	GUIDelete()
EndFunc

Func CountOvensCompleted($OvenCount)
	$ZC = 0
	$OC = 1
	For $ZC = $OvenCount to 1 Step -1
		if $OvenFinished[$ZC] = 1 Then
			$OC = $OC+1
		EndIf
	Next
	If $OC = $OvenCount then 
		return 1
	EndIf
	If $OC < $OvenCount then 
		return 0
	EndIf
EndFunc

Func CheckOvenStatus($x, $y, $bx, $by, $ocntr)
PixelSearch($x+100, $y+60, $x+100, $y+60, $GUIInput[12], 100)
	If not @error Then
		MouseClick("Right", $bx+50, $by, 2, 0)
		MouseClick("Right", $bx+150, $by, 1, 0)
		$OvenFinished[$ocntr] = 1
		return 1
	Else
		return 0
	EndIf
EndFunc

Func OvenControl($OvenCount)
	$Counter = 1
	$JumpCounter = 1
	$ScanBarX = $WinX + $CheckBarsScanStartX
	$ScanBarY = $WinY + $CheckBarsStartY
	$ButtonX = $WinX + $AddButtonsScanX
	$ButtonY = $WinY + $AddButtonsConstY
	$i = 0
	While $i < $OvenCount
		$i=$i+1
		$OvenFinished[$i] = 0
		$WoodAdded[$i] = 0
		$WaterAdded[$i] = 0
		$TimeWoodAdded[$i] = 0
		$TimeWaterAdded[$i] = 0
		$OxyPrime[$Counter] = 0
	Wend
$OvensCompleted = 0
OvenStatusGUI($counter, $OvenCount)
sleep(300)
	While $OvensCompleted = 0
		If $ExitProgram = 6 Then ExitLoop
		$Xcounter = 1
		$SleepInit = TimerInit()
		While $XCounter < $OvenCount
		$Skip = 0
			If $Counter = $OvenCount Then 
					$Counter = 1
					$ScanBarX = $WinX + $CheckBarsScanStartX
					$ScanBarY = $WinY + $CheckBarsStartY
					$ButtonX = $WinX + $AddButtonsScanX
					$ButtonY = $WinY + $AddButtonsConstY
					$JumpCounter = 1
			EndIf
			If $OvenFinished[$counter] = 1 Then
				$Skip = 1
			EndIf
			If $ExitProgram = 6 Then Exit
			If $JumpCounter = $OvenRowEnd + 1 Then
				$ScanBarX = $ScanBarX - (($JumpCounter - 1) * $OvenWidth) + $TrimX
				$ScanBarY = $ScanBarY + $OvenHeight + $TrimY
				$ButtonX = $ButtonX - (($JumpCounter - 1) * $OvenWidth) + $TrimX
				$ButtonY = $ButtonY + $OvenHeight + $TrimY
				$JumpCounter = 1
			EndIf
			If $Skip < 1 Then		
				$HeatBar = ScanBar($ScanBarX, $ScanBarY)
				GUICtrlSetData($HeatLabel, $HeatBar)
				$OxygenBar = ScanBar($ScanBarX, $ScanBarY+12)
				GUICtrlSetData($OxyLabel, $OxygenBar)
				$WoodBar = ScanBar($ScanBarX, $ScanBarY+24)
				GUICtrlSetData($WoodLabel, $WoodBar)
				$WaterBar = ScanBar($ScanBarX, $ScanBarY+36)
				GUICtrlSetData($WaterLabel, $WaterBar)
				$DangerBar = ScanBar($ScanBarX, $ScanBarY+48)
				GUICtrlSetData($DangerLabel, $DangerBar)
				$StatusBar = ScanBar($ScanBarX, $ScanBarY+60)
				GUICtrlSetData($StatLabel, $StatusBar)
				$HeatLow = $GUIInput[4]
				$HeatHigh = $GUIInput[5]
				$OxyLow = $GUIInput[6]
				$OxyHigh = $GUIInput[7]
				$MaxWood = $GUIInput[8]
				$MaxWood2 = $GUIInput[8]
				$MaxWater = $GUIInput[9]
				$DangerLow = $GUIInput[10]
				$DangerHigh = $GUIInput[11]
				$CheckThisOven = CheckOvenStatus($ScanBarX, $ScanBarY, $ButtonX, $ButtonY, $Counter)
				If $CheckThisOven = 1 Then $Skip=1
				If $CheckThisOven = 0 Then $Skip=0
				If $WoodBar < 15 and $DangerBar < $DangerHigh and $Skip < 1 Then
					MouseClick("Right", $ButtonX, $ButtonY, 1, 0)
				EndIf
				If $HeatBar < $HeatLow or $DangerBar < $DangerLow and $skip < 1 and $WoodBar < $MaxWood or $HeatBar < $WoodAdded[$counter] Then
					MouseClick("Right", $ButtonX, $ButtonY, 1, 0)
					$WoodAdded[$Counter] = $HeatBar
				EndIf
				If $DangerBar > $DangerHigh and $WaterBar < $MaxWater and $DangerBar > $WaterAdded[$counter] and $skip < 1 Then
					MouseClick("Right", $ButtonX+50, $ButtonY, 1, 0)
					$wateradded[$Counter] = $DangerBar
				EndIf
				If $OxygenBar < $OxyLow and $OxyPrime[$Counter] < 1 and $skip < 1 Then
					If $ventPosition[$counter] <> 3 Then
						MouseClick("Right", $ButtonX+150, $ButtonY, 1, 0)
					EndIf
					$Ventposition[$counter] = 3
				EndIf
				If $OxygenBar < $OxyLow and $OxyPrime[$counter] = 1 and $skip < 1 Then
					If $VentPosition[$counter] <> 2 Then
						MouseClick("Right", $ButtonX+125, $ButtonY, 1, 0)
					EndIf
					$VentPosition[$counter] = 2
					If $OxyCheck[$counter] = 0 Then
						$OxyPrime[$counter] = 0
					EndIf
					If $OxyCheck[$counter] = 1 Then
						$OxyCheck[$counter] = 0
					EndIf
					If $OxyCheck[$counter] = 2 Then
						$OxyCheck[$counter] = 1
					EndIf
				EndIf
				If $OxygenBar > $OxyLow and $OxygenBar < $OxyHigh and $OxyPrime[$Counter] = 0  and $skip < 1 Then
					If $VentPosition[$counter] <> 2 Then
						MouseClick("Right", $ButtonX+125, $ButtonY, 1, 0)
					EndIf
					$VentPosition[$counter] = 2
				EndIf
				If $OxygenBar > $OxyLow and $OxygenBar > $OxyHigh and $skip < 1 Then
					If $VentPosition[$counter] <> 1 then
						MouseClick("Right", $ButtonX+100, $ButtonY, 1, 0)
					EndIf
					$VentPosition[$counter] = 1
					$OxyPrime[$Counter] = 1
					$OxyCheck[$counter] = 2
				EndIf
				$Counter = $Counter + 1
				$JumpCounter = $JumpCounter + 1
				$ScanBarX = $ScanBarX + $Ovenwidth
				$ButtonX = $ButtonX + $Ovenwidth
			Else
				$Counter = $Counter + 1
				$JumpCounter = $JumpCounter + 1
				$ScanBarX = $ScanBarX + $Ovenwidth
				$ButtonX = $ButtonX + $Ovenwidth
			EndIf
			$OvensCompleted = CountOvensCompleted($OvenCount)
			$XCounter = $Xcounter+1
		Wend
	sleep(2000-TimerDiff($SleepInit))
	Wend
	GUIDelete()
	return 0
EndFunc

Func Main($Process)
WinActivate("eGenesis Client", "")
$BackToGUI = 0
	While $BackToGUI = 0
		If $Process = 1 Then			
			If $GUIInput[2] = 1 Then 
				Guild()
			Else 
				UnGuilded()
			EndIf
			If $GUIInput[3] = 1 Then
				SetupOvens($GUIInput[1]+1)
			Else
			EndIf
			StartOvens($GUIInput[1]+1)
			$process = OvenControl($GUIInput[1]+1)
		EndIf
		If $Process=0 Then 
		msgbox(0, "Status Message", "All Ovens Completed!") 
		LoadGUI()
		EndIf
	Wend
EndFunc

While 1
LoadGUI()
Wend